package zone.oat.supersecretrevival;

import net.minecraft.client.MinecraftClient;
import net.minecraft.client.sound.PositionedSoundInstance;
import net.minecraft.client.world.ClientWorld;
import net.minecraft.sound.SoundCategory;
import net.minecraft.sound.SoundEvent;
import net.minecraft.sound.SoundEvents;
import net.minecraft.util.registry.Registry;
import net.minecraft.world.World;

import java.util.Arrays;
import java.util.Random;

public class RandomSoundPlayer {

    private static final Random RANDOM = new Random();

    // prevent these sounds from playing
    //
    // in 1.8 this used to be a list of categories;
    // however sounds no longer have an association
    // to categories so we have to improvise

    private static SoundEvent[] soundBlocklist = {
            SoundEvents.MUSIC_CREATIVE,
            SoundEvents.MUSIC_CREDITS,
            SoundEvents.MUSIC_DISC_11,
            SoundEvents.MUSIC_DISC_13,
            SoundEvents.MUSIC_DISC_BLOCKS,
            SoundEvents.MUSIC_DISC_CAT,
            SoundEvents.MUSIC_DISC_CHIRP,
            SoundEvents.MUSIC_DISC_FAR,
            SoundEvents.MUSIC_DISC_MALL,
            SoundEvents.MUSIC_DISC_MELLOHI,
            SoundEvents.MUSIC_DISC_PIGSTEP,
            SoundEvents.MUSIC_DISC_STAL,
            SoundEvents.MUSIC_DISC_STRAD,
            SoundEvents.MUSIC_DISC_WAIT,
            SoundEvents.MUSIC_DISC_WARD,
            SoundEvents.MUSIC_DRAGON,
            SoundEvents.MUSIC_END,
            SoundEvents.MUSIC_GAME,
            SoundEvents.MUSIC_MENU,
            SoundEvents.MUSIC_NETHER_BASALT_DELTAS,
            SoundEvents.MUSIC_NETHER_CRIMSON_FOREST,
            SoundEvents.MUSIC_NETHER_NETHER_WASTES,
            SoundEvents.MUSIC_NETHER_SOUL_SAND_VALLEY,
            SoundEvents.MUSIC_NETHER_WARPED_FOREST,
            SoundEvents.MUSIC_UNDER_WATER,

            SoundEvents.AMBIENT_CAVE,
            SoundEvents.AMBIENT_BASALT_DELTAS_ADDITIONS,
            SoundEvents.AMBIENT_BASALT_DELTAS_LOOP,
            SoundEvents.AMBIENT_BASALT_DELTAS_MOOD,
            SoundEvents.AMBIENT_CRIMSON_FOREST_ADDITIONS,
            SoundEvents.AMBIENT_CRIMSON_FOREST_LOOP,
            SoundEvents.AMBIENT_CRIMSON_FOREST_MOOD,
            SoundEvents.AMBIENT_NETHER_WASTES_ADDITIONS,
            SoundEvents.AMBIENT_NETHER_WASTES_LOOP,
            SoundEvents.AMBIENT_NETHER_WASTES_MOOD,
            SoundEvents.AMBIENT_SOUL_SAND_VALLEY_ADDITIONS,
            SoundEvents.AMBIENT_SOUL_SAND_VALLEY_LOOP,
            SoundEvents.AMBIENT_SOUL_SAND_VALLEY_MOOD,
            SoundEvents.AMBIENT_WARPED_FOREST_ADDITIONS,
            SoundEvents.AMBIENT_WARPED_FOREST_LOOP,
            SoundEvents.AMBIENT_WARPED_FOREST_MOOD,
            SoundEvents.AMBIENT_UNDERWATER_ENTER,
            SoundEvents.AMBIENT_UNDERWATER_EXIT,
            SoundEvents.AMBIENT_UNDERWATER_LOOP,
            SoundEvents.AMBIENT_UNDERWATER_LOOP_ADDITIONS,
            SoundEvents.AMBIENT_UNDERWATER_LOOP_ADDITIONS_RARE,
            SoundEvents.AMBIENT_UNDERWATER_LOOP_ADDITIONS_ULTRA_RARE,
    };

    private static SoundEvent getRandomSound(Random random) {
        SoundEvent event;

        Registry<SoundEvent> registry = Registry.SOUND_EVENT;
        int size = registry.getEntries().size();
        do {
            int rand = random.nextInt(size);
            event = registry.get(rand);
        } while (Arrays.asList(soundBlocklist).contains(event));

        return event;
    }

    // money back guarantee. Bill mays. Phil swif
    // In this phrase "money-back" is an adjective and needs to be spelled with a hyphen.
    // Incorrect: We offer a 14-day money back guarantee.
    // Correct: We offer a 14-day money-back guarantee.
    public static void guaranteedPlaySound(SoundEvent sound, float volume, float pitch) {
        MinecraftClient client = MinecraftClient.getInstance();
        World world = client.world;

        if (world instanceof ClientWorld) {
            world.playSound(
                    client.player,
                    client.player.getBlockPos(),
                    sound,
                    SoundCategory.MASTER,
                    volume,
                    pitch
            );
        } else {
            client.getSoundManager().play(PositionedSoundInstance.master(sound, pitch));
        }
    }

    public static void playRandomSound() {
        SoundEvent sound = getRandomSound(RANDOM);
        guaranteedPlaySound(sound, 1f, 0.5f);
    }
}
